#include <boost/marshall/marshall.hpp>
#include <iostream>

void func2( int i, int j )
{
	std::cout << "i: " << i << " j:" << j << std::endl;
}

void func1(int i)
{
	std::cout << "i: " << i << std::endl;
}

void func0()
{
	std::cout << "void: " << std::endl;
}

namespace marshall = boost::marshall;

void basic_marshall_test()
{
	marshall::registry<int> reg;

	reg.set<void (int, int)>(2, func2); // register function
	reg.set<void (int)>(1, func1); // register function
	reg.set<void ()>(0, func0); // register function

	// embed the function id into the call as well as two parameters
	std::string call2_5_6 = marshall::serialize<int, void (int, int)>(2, 5, 6);
	// embed just two parameters
	std::string call_5_6 = marshall::serialize<void (int, int)>(5, 6);
	// embed just one parameter
	std::string call_5 = marshall::serialize<void (int)>(7);
	// embed nothing
	std::string call = marshall::serialize<void ()>();

	reg(call2_5_6); // call via the embedded function id
	reg(2, call_5_6); // call by specifying the id
	reg(1, call_5); // call by specifying the id
	reg(1, call_5_6); // no checking to see if extra parameters are left over
	reg(0, call); // call by specifying the id
}
