template<typename Signature>
class marshalled_impl<Signature, BOOST_ARITY_NUM_ARGS> : public function
{
	BOOST_ARITY_STORABLE_TYPES(Signature)
	BOOST_ARITY_TYPES(Signature)
public:
	marshalled_impl(const boost::function<Signature> &f) : func(f)
	{}
	virtual void call(boost::archive::binary_iarchive &archive)
	{
		BOOST_ARITY_STORABLES(BOOST_ARITY_NUM_ARGS)
		BOOST_ARITY_ON_STORABLES(BOOST_ARITY_NUM_ARGS,archive & )

		func(BOOST_PP_ENUM_SHIFTED_PARAMS(BOOST_ARITY_NUM_ARGS_INC,arg_storable));
	};
private:
	boost::function<Signature> func;
};

} // namespace detail

template<typename Signature>
static std::string serialize(BOOST_ARITY_TYPE_PARMS_LONG(Signature))
{
	std::stringstream stream;
	boost::archive::binary_oarchive archive(stream);
	BOOST_ARITY_ON_PARMS(BOOST_ARITY_NUM_ARGS,archive & )
	return stream.str();
}

template<typename Id, typename Signature>
std::string serialize(Id id BOOST_ARITY_COMMA BOOST_ARITY_TYPE_PARMS_LONG(Signature))
{
	std::stringstream stream;
	boost::archive::binary_oarchive archive(stream);
	archive & id;
	BOOST_ARITY_ON_PARMS(BOOST_ARITY_NUM_ARGS,archive & )
	return stream.str();
}

namespace detail {